/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.2 Beta1 Standard
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 11.08.2009
Author  : Alexey                          
Company : Home                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>          
#include <delay.h>    

#define ADC_pusk ADCSRA|=0x40
#define ADC_VREF_TYPE 0x00  
#define ind_des PORTB=0b11111110  // 
#define ind_ed  PORTB=0b11111101  // 
#define ind_dro PORTB=0b11111011  // 
#define pause delay_ms(5)

// Declare your global variables here
 unsigned int adc_data, //  
              adc_data_sred;  //  
 unsigned long n=1; //               
        float DCV_displey=888;
 static char digits[] = {
   0b00111111, //0
   0b00000110, //1
   0b01011011, //2
   0b01001111, //3
   0b01100110, //4
   0b01101101, //5
   0b01111101, //6
   0b00000111, //7
   0b01111111, //8
   0b01101111, //9
   
   0b10111111, //0.
   0b10000110, //1.
   0b11011011, //2.
   0b11001111, //3.
   0b11100110, //4.
   0b11101101, //5.
   0b11111101, //6.
   0b10000111, //7.
   0b11111111, //8.
   0b11101111 //9.
};
 
// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
 // Read the AD conversion result
 adc_data=ADCW;     
 adc_data_sred=((n-1)*adc_data_sred + adc_data)/n;
 n=n+1;    
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x64;                  

// Place your code here
ADC_pusk;
}     

// Timer 1 overflow interrupt service routine  0,5      ,    
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// Reinitialize Timer 1 value
TCNT1H=0x85;
TCNT1L=0xEE;
// Place your code here 
DCV_displey=adc_data*150.0/1024.0;
n=1;
}

void Displey(void)
{
   unsigned int data=DCV_displey;
   // dro   
   ind_dro;
   PORTD=digits[data%10];
   pause;
   data=data/10;
   // ed   
   ind_ed;
   PORTD = digits[data%10+10];
   pause;
   data=data/10;
   // des   
   ind_des;
   PORTD = digits[data%10];
   pause;
}

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=P State3=P State2=1 State1=1 State0=1 
PORTB=0xFF;
DDRB=0x07;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=P State5=P State4=P State3=P State2=P State1=P State0=T 
PORTC=0x7E;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x05;
TCNT0=0x64;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x85;
TCNT1L=0xEE;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x8F;          

// Global enable interrupts
#asm("sei")

while (1)
      {
       // Place your code here
       Displey();
      };
}