
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned int adc_data, 
adc_data_sred;  
unsigned long n=1; 
float DCV_displey=888;
static char digits[] = {
0b00111111, 
0b00000110, 
0b01011011, 
0b01001111, 
0b01100110, 
0b01101101, 
0b01111101, 
0b00000111, 
0b01111111, 
0b01101111, 

0b10111111, 
0b10000110, 
0b11011011, 
0b11001111, 
0b11100110, 
0b11101101, 
0b11111101, 
0b10000111, 
0b11111111, 
0b11101111 
};

interrupt [15] void adc_isr(void)
{

adc_data=ADCW;     
adc_data_sred=((n-1)*adc_data_sred + adc_data)/n;
n=n+1;    
}

interrupt [10] void timer0_ovf_isr(void)
{

TCNT0=0x64;                  

ADCSRA|=0x40;
}     

interrupt [9] void timer1_ovf_isr(void)
{

TCNT1H=0x85;
TCNT1L=0xEE;

DCV_displey=adc_data*150.0/1024.0;
n=1;
}

void Displey(void)
{
unsigned int data=DCV_displey;

PORTB=0b11111011  ;
PORTD=digits[data%10];
delay_ms(5);
data=data/10;

PORTB=0b11111101  ;
PORTD = digits[data%10+10];
delay_ms(5);
data=data/10;

PORTB=0b11111110  ;
PORTD = digits[data%10];
delay_ms(5);
}

void main(void)
{

PORTB=0xFF;
DDRB=0x07;

PORTC=0x7E;
DDRC=0x00;

PORTD=0x00;
DDRD=0xFF;

TCCR0=0x05;
TCNT0=0x64;

TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x85;
TCNT1L=0xEE;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x05;

ACSR=0x80;
SFIOR=0x00;

ADMUX=0x00  ;
ADCSRA=0x8F;          

#asm("sei")

while (1)
{

Displey();
};
}
